function arr_m = save_res2_by_arr_m(res_rperi, arr_m, data, tid, dosave)
% INPUT
%   res_rperi:	A 1D cell array. Each cell contains an 1D array of structs, each struct contains the
%               properties of the iterate of a given algorithm. These
%               properties are:
%               - SR:      Sampling rate of the problem, this value certains
%                          repeats along the results of one single test. 
%               - HPs:     An 1D array of regularization parameters, see
%                          param_pb.paramd. 
%               - Ite:     Number of the repeated test. 
%               - rank:    CP rank paramter of the problem model.
%               
%               (NOTE: the above three entries are constant in each
%               test, therefore, they could be appended after `stats`
%               in runmethods_fromlist.m is produced.) 
%               
%               - iter:    Number of iteration.
%               - time:    Wall time from the intial time to the current
%                          point. 
%               - RMSE_tr: Training error of the iterate in terms of RMSE.
%               - RMSE_t:  Test error of the iterate in terms of RMSE.
%               - RMSE:    RMSE of the iterate (on all the known
%                          entries available).
%               - relErr:  Relative error of the iterate (on all the
%                          known entries available).
%
%   arr_m:      An 1D array of structs. Each element contains the method
%               information such as method name, the manifold name (if
%               applicable) etc.
%   dataname:   Name of the dataset, eg., the name generated by gen_gtensors.m
%               and load_tensor.m
%   tid:        A string of test id (time and date).
%
% OUTPUT
%   arr_m:      Same as input with one more field for each element: res_peri, the 1D
%               array of iteration history.
% 
% Latest version: June 2020.
% Contact: shuyu.dong@uclouvain.be

if nargin < 5
	dosave = true;
end
dir_name = './archive'; 
if ~isdir(dir_name)
    mkdir(dir_name); 
    fprintf('The subfolder %s is created now!\n', dir_name); 
end
dataname = data.name; 
filename = sprintf('%s_%s', dataname, tid); 

tab_m = struct2table(arr_m); 
labels = table2cell(tab_m(:,'name')); 

for i = 1 : numel(arr_m)
    arr_m(i).res = res_rperi{i}; 
    arr_m(i).fid = filename;
end

if dosave
    fprintf('Saving a matfile to %s\n', dir_name); 
	save(sprintf('%s/%s.mat', dir_name, filename), 'arr_m', 'tab_m', 'labels',...
	    'data', 'tid'); 
end

end
